/* 70-762 Lesson 10 Lab 1 Connection 1 - Using Dynamic Management Views (DMVs) to Obtain Lock Information */

/* Create Lesson 10 lab environment */
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Create tables in Examples schema of WideWorldImporters database<<<<-----------------
USE WideWorldImporters;
GO

DROP TABLE IF EXISTS Examples.LockingTable1;
GO

DROP TABLE IF EXISTS Examples.LockingTable2;
GO

CREATE TABLE Examples.LockingTable1
	(col1 int NOT NULL
		CONSTRAINT PK_Examples_LockingTable1 PRIMARY KEY,
	col2 varchar(100) NOT NULL);

INSERT INTO Examples.LockingTable1 (col1, col2)
VALUES (1, 'Red'), (2, 'Orange'), (3, 'Yellow'), (4, 'Green');
GO

-----------------------
CREATE TABLE Examples.LockingTable2
	(col1 int NOT NULL
		CONSTRAINT PK_Examples_LockingTable2 PRIMARY KEY,
	col2 varchar(100) NOT NULL);

INSERT INTO Examples.LockingTable2 (col1, col2)
VALUES (1, 'Blue'), (2, 'Indigo'), (3, 'Violet'), (4, 'Spectrum');
GO

-------------------------------------------------------
/*--EXAMPLE 1 Using sys.dm_tran_locks----------------*/
---CONNECTION 1---------------------------------------

USE WideWorldImporters;
GO

--Begin UPDATE transaction without committing------
BEGIN TRANSACTION;
	UPDATE Examples.LockingTable1
	SET col2 = 'Peach is the new Orange'
	WHERE col1 = 2;

----------------------------------
--------------------------------------
--Go to Lab 1 Connection 2-------------

----Returning from connection 2----
--Use sys.dm_tran_locks to view lock information---
--The following query displays some but not all colummns--

SELECT
	request_session_id,
	resource_type,
	resource_database_id AS dbid,
	DB_NAME(resource_database_id) AS dbname,
	resource_description,
	resource_associated_entity_id,
	request_mode AS mode,
	request_status AS status
FROM sys.dm_tran_locks
WHERE resource_database_id = db_id('WideWorldImporters');
GO

--To view the resource blocked
--use the resource_associated_entity_id--
--from the previous query in the following
--select statement------------------------
SELECT
	object_name(object_id) AS Resource,
	object_id,
	hobt_id
FROM sys.partitions
--WHERE hobt_id =     --complete with id
WHERE hobt_id = 72057594071613440;

---To view information regarding connections
---associated with sessions ---
---use sys.dm_exec_connections filtering
---only the session IDs involved in the
---blocking chain----------------------

SELECT
	session_id,
	connect_time,
	last_read,
	last_write,
	most_recent_sql_handle
FROM sys.dm_exec_connections
--WHERE session_id IN(<filter sessions involved in blocking>)
WHERE session_id IN(51,59);

--To find the most recent batch of code
--involved in the block, use
--sys.dm_exec_sql_text
--RUN THE FOLLOWING CODE IN CONNECTION 3
--IMMEDIATELY AFTER RUNNING THE TWO ORIGINAL QUERIES FROM
--connections 1 and 2

/*--THIS CODE IS RUN IN Lab 1 Connection 3-----*/
--SELECT
--	session_id,
--	text
--FROM sys.dm_exec_connections
--CROSS APPLY sys.dm_exec_sql_text(most_recent_sql_handle) AS ST
--WHERE session_id IN(57,60); --again change the session id for current query

--End transaction by rolling it back
ROLLBACK TRANSACTION; 

/*--Start a new transaction for the next section--*/
/*  of Lab 1--------------------------------------*/

--Begin UPDATE transaction without committing------
BEGIN TRANSACTION;
	UPDATE Examples.LockingTable1
	SET col2 = 'Peach is the new Orange'
	WHERE col1 = 2;

----------------------------------
--------------------------------------
--Go to Lab 1 Connection 2-------------
--Then proceed to connection 3 -------

--Returning from Connection 3-----------
----------------------------------------
----------------------------------------
/*--EXAMPLE 2--------------------------*/
--Using DMV sys.dm_exec_requests
--to find information about blocked requests
--Filter for blocked requests by noting 
--attribute blocking_session_id > 0
--WAIT_TYPE
--LCK_M_S occurs when a task is waiting to acquire a Shared lock

SELECT session_id ,status ,blocking_session_id  
    ,wait_type ,wait_time ,wait_resource   
    ,transaction_id 
FROM sys.dm_exec_requests
WHERE blocking_session_id > 0;


----------------------------------------
----------------------------------------
/*--EXAMPLE 3--------------------------*/
--Yet another useful DMV is sys.dm_os_waiting_tasks
--which has tasks that are currently waiting
--Query attribute blocking_session_id > 0 
--to filter only waiting tasks
SELECT * FROM sys.dm_os_waiting_tasks 
WHERE blocking_session_id IS NOT NULL;

--------------------------------------------
--------------------------------------------
--Close lab by rolling back transaction

ROLLBACK TRANSACTION;


