/* 70-762 Lesson 11 Lab 3 - Using System Stored Procedures to Collect Execution Statistics */

--First 4 Examples are for reference only-------------------------------
--Proceed to section labeled Step 5 to continue exercise
--from previous labs in lesson-----------------------------------------

USE Certimoltp;
GO

---------------------------------------------------------------------
/* EXAMPLE 1 */
-->>Enable, view, and disable statistics collection at procedure level<<--

--To enable statistics collection at procedure level:--
EXEC sys.sp_xtp_control_proc_exec_stats @new_collection_value = 1;
GO

--To check current status of statistics collection at procedure level:--
--Output value of (1) specifies procedure-level statistics collection is on
--otherwise off (0)
DECLARE @c BIT;
EXEC sys.sp_xtp_control_proc_exec_stats @old_collection_value = @c OUTPUT
SELECT @c AS 'Current statistics collection status'
GO

--To disable statistics collection at procedure level:--
EXEC sys.sp_xtp_control_proc_exec_stats @new_collection_value = 0;
GO

-----------------------------------------------------------------------
-----------------------------------------------------------------------
/* EXAMPLE 2 */
-->>Enable, view, and disable statistics collection at query level<<--

-----------------------------------------------------
--To enable statistics collection at query level:--
EXEC sys.sp_xtp_control_query_exec_stats @new_collection_value = 1;
GO

--To check current status of statistics collection at query level:--
--Output value of (1) specifies procedure-level statistics collection is on
--otherwise off (0)
DECLARE @c BIT;
EXEC sys.sp_xtp_control_query_exec_stats @old_collection_value = @c OUTPUT
SELECT @c AS 'Current statistics collection status'
GO

--To disable statistics collection at query level:--
EXEC sys.sp_xtp_control_query_exec_stats @new_collection_value = 0;
GO

-------------------------------------------------------------------
-------------------------------------------------------------------
/* EXAMPLE 3 */
-->>Query Returns information about the top 5 stored procedures identified by average elapsed time<<-
SELECT TOP 5 ps.object_id, ps.database_id, OBJECT_NAME(object_id, database_id) 'proc name',   
    ps.cached_time, ps.last_execution_time, ps.total_elapsed_time,  
    ps.total_elapsed_time/ps.execution_count AS [avg_elapsed_time],  
    ps.last_elapsed_time, ps.execution_count  
FROM sys.dm_exec_procedure_stats AS ps  
ORDER BY [total_worker_time] DESC;

------------------------------------------------------------------
------------------------------------------------------------------
/* EXAMPLE 4 */
-->>Query results includes a row for each statement
-->>in the natively-compiled stored procedure
-->>as well as the query text of each statement
SELECT 
	STEX.objectid AS 'Object ID',
	OBJECT_NAME(STEX.objectid) AS 'Object Name',
	SUBSTRING(STEX.text, (QS.statement_start_offset/2) + 1,  
    ((QS.statement_end_offset - QS.statement_start_offset)/2) + 1)   
        AS 'Statement Text',
	QS.last_execution_time AS 'Last Execution Time',
	QS.execution_count AS 'Execution Count' 
FROM sys.dm_exec_query_stats AS QS  
     CROSS APPLY sys.dm_exec_sql_text(QS.sql_handle) AS STEX  
INNER JOIN sys.all_sql_modules SM
	ON SM.object_id = STEX.objectid
WHERE SM.uses_native_compilation = 1;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-----------------------------------------------------------------------------------
--Exercise continues from Lab 2
----------------------------------------------------------------------------------
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
/*>>>>STEP 5<<<<*/
/*>>>Lesson 11 Lab 3<<<*/
USE Certimoltp;
GO

--To enable statistics collection at procedure level:--
EXEC sys.sp_xtp_control_proc_exec_stats @new_collection_value = 1;
GO

DECLARE @so_id INT = 22,  
       @cust_id INT = 8,  
       @items dbo.SalesOrderDetailsType  
INSERT @items  VALUES   
       (@so_id, 1, 4, 43),   
       (@so_id, 2, 3, 3),   
       (@so_id, 3, 8, 453),   
       (@so_id, 4, 5, 76),   
       (@so_id, 5, 4, 43)  
EXEC dbo.InsertSalesOrder @so_id, @cust_id, @items  
GO  

-- verify the content of the tables  
SELECT   
       so.so_id,  
       so.so_date,  
       sod.lineitem_id,  
       sod.product_id,  
       sod.unitprice  
FROM dbo.SalesOrders so JOIN dbo.SalesOrderDetails sod on so.so_id=sod.so_id  
ORDER BY so.so_id, sod.lineitem_id;
GO

-->>Query Returns information about the top 5 stored procedures identified by average elapsed time<<-
SELECT TOP 5 ps.object_id, ps.database_id, OBJECT_NAME(object_id, database_id) 'proc name',   
    ps.cached_time, ps.last_execution_time, ps.total_elapsed_time,  
    ps.total_elapsed_time/ps.execution_count AS [avg_elapsed_time],  
    ps.last_elapsed_time, ps.execution_count  
FROM sys.dm_exec_procedure_stats AS ps  
ORDER BY [total_worker_time] DESC;
GO

--To disable statistics collection at procedure level:--
EXEC sys.sp_xtp_control_proc_exec_stats @new_collection_value = 0;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>