/* 70-762 Lesson 13 Lab 1 - Using Extended Events to Capture Query Plans */

/* EXAMPLE 1 */
--Create and start an extended event session to capture
--query plan-------------------------------------------

USE master;
GO

IF EXISTS
	(SELECT *
	FROM sys.server_event_sessions
	WHERE name = 'WWIQueryPlans')
	DROP EVENT SESSION WWIQueryPlans
	ON SERVER;
GO

CREATE EVENT SESSION WWIQueryPlans
ON SERVER
ADD EVENT sqlserver.query_post_execution_showplan
	(ACTION
	(sqlserver.database_name,
	sqlserver.client_app_name,
	sqlserver.plan_handle,
	sqlserver.sql_text,
	sqlserver.sql_text,
	package0.callstack,
	sqlserver.query_hash,
	sqlserver.session_id,
	sqlserver.request_id)
WHERE
	sqlserver.database_name = 'WideWorldImporters'
AND
	object_type = 'ADHOC'
	)
ADD TARGET package0.event_file
(SET filename = N'C:\_Pearson_SQL_Server 70-762 Developing SQL Databases\Lesson 13\WWIQueryPlans13.xel', --create file location
				max_file_size = (5), max_rollover_files = (4)),
ADD TARGET package0.ring_buffer
				WITH (MAX_DISPATCH_LATENCY = 5SECONDS, TRACK_CAUSALITY = ON);
GO

-------
ALTER EVENT SESSION WWIQueryPlans
	ON SERVER
	STATE = START;
GO

-----------------------------------
--click the Extended Events Sessions node
--Right click WWIQueryPlans and
--select Watch Live Data

Use WideWorldImporters;
GO

SELECT *
FROM Warehouse.StockItems;
GO


-------------------------------------
--Disable extended event session
ALTER EVENT SESSION WWIQueryPlans
	ON SERVER
	STATE = STOP;
GO

--Drop extended event session
IF EXISTS
	(SELECT *
	FROM sys.server_event_sessions
	WHERE name = 'WWIQueryPlans')
	DROP EVENT SESSION WWIQueryPlans
	ON SERVER;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>