/* 70-762 Lesson 14 Lab 3 - Using Object Explorer Properties and T-SQL to Configure Memory */

/*
To set a fixed amount of memory 

In Object Explorer, right-click server and select Properties. 
Click the Memory node. 
Under Server Memory Options, 
  enter the amount that you want for
  Minimum server memory and Maximum server memory 
Use the default settings
  to allow SQL Server to change its memory requirements dynamically
  based on available system resources
Default setting for min server memory 0,
  and the default setting for max server memory 2147483647 megabytes (MB) 
*/


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Determining the current memory allocation

SELECT  
(physical_memory_in_use_kb/1024) AS Memory_usedby_Sqlserver_MB,  
(locked_page_allocations_kb/1024) AS Locked_pages_used_Sqlserver_MB,  
(total_virtual_address_space_kb/1024) AS Total_Virtual_Address_Space_in_MB,-- memory allocated to SQL  
process_physical_memory_low,  
process_virtual_memory_low  
FROM sys.dm_os_process_memory;
GO
--------------------------------------------------------------------------------------------

--Listing the advanced configuration options
USE master;  
GO  
EXEC sp_configure 'show advanced option', 1;
GO
RECONFIGURE;  
GO 
EXEC sp_configure;
GO
-------------------------------------------------------------------

--Configuring minimum memory per query  
EXEC sp_configure 'show advanced options', 1;  
GO  
RECONFIGURE;  
GO  
EXEC sp_configure 'min memory per query', 1024 ;  
GO  
RECONFIGURE;  
GO
----------------------------------------------------------
--Configuring maximum worker threads------------
USE master;  
GO  
EXEC sp_configure 'show advanced options', 1;  
GO  
RECONFIGURE;  
GO  
EXEC sp_configure 'max worker threads', 0 ;  
GO  
RECONFIGURE;  
GO

-------------------------------------------------
--Turning off advanced options
EXEC sp_configure 'show advanced options', 0;  
GO 
RECONFIGURE;  
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>