/* 70-762 Lesson 14 Lab 4 - Using Wait Statistics DMVs */

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

--The following returns wait information from sys.dm_os_wait_stats
SELECT TOP 20
wait_type AS 'Type of Wait',
wait_time_ms / 1000.0 AS 'Total Wait Time in seconds',
  signal_wait_time_ms / 1000.0 AS 'Signal Wait Time in seconds',
waiting_tasks_count AS 'Waiting Tasks Count',
100.0 * wait_time_ms / SUM (wait_time_ms) OVER() AS 'Percentage',
ROW_NUMBER() OVER(ORDER BY wait_time_ms DESC) AS 'Row Number'
FROM sys.dm_os_wait_stats
GO
----------------------------------------------------------------
--The following identifies high signal waits - CPU pressure
--Percentage of time thread is waiting for its turn to run
SELECT  SUM(signal_wait_time_ms) AS 'Total Signal Wait Time' ,
        ( SUM(CAST(signal_wait_time_ms AS NUMERIC(20, 2)))          
		/ SUM(CAST(wait_time_ms AS NUMERIC(20, 2))) * 100 )                        
		 AS 'Percentage Signal Waits Of Total Time' 
FROM    sys.dm_os_wait_stats;
GO


--The following resets contents of sys.dm_os_wait_stats
DBCC SQLPERF ('sys.dm_os_wait_stats', CLEAR);  
GO

--Using sys.dm_os_schedulers to analyze
--scheduler queues
/*
The filter for schedulers below 255
 removes from the result set hidden schedulers
 used for backups, the Dedicated Administrator Connection (DAC),
 not of interest when investigating general CPU load
 -- Tasks on current_tasks_count but not runnable_tasks_ count
 -- are either sleeping or waiting for resource 
*/
SELECT  scheduler_id,
        current_tasks_count,
		runnable_tasks_count 
FROM    sys.dm_os_schedulers 
WHERE   scheduler_id < 255;
GO

--The following identifies blocked sessions
--using sys.dm_os_waiting_tasks 
SELECT * FROM sys.dm_os_waiting_tasks 
WHERE blocking_session_id IS NOT NULL;
GO

--The following lists waiting tasks
--by wait duration - descending
SELECT * FROM sys.dm_os_waiting_tasks 
ORDER BY wait_duration_ms DESC;
GO


-----------------------------------------------------------------
--The following shows how several dynamic metadata views
--can be related for monitoring schedule statistics
SELECT
 dot.scheduler_id, -- parent scheduler
 task_state,
 COUNT (*) AS task_count
FROM sys.dm_os_schedulers dos 
INNER JOINsys.dm_os_workersdow 
	ON dos.scheduler_address=dow.scheduler_address
INNER JOINsys.dm_os_tasks AS dot 
	ON dot.task_address=dow.task_address
INNER JOINsys.dm_exec_requests AS der
	ON dot.session_id = der.session_id
INNER JOINsys.dm_exec_sessions AS des
	ON der.session_id = des.session_id
WHERE des.is_user_process = 1  -- session is not a system session
GROUP BY
 dot.scheduler_id,
 task_state
ORDER BY task_state,dot.scheduler_id;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>.
