/* 70-762 Lesson 14 Lab 6 - Using Performance Counters to Monitor Memory */


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--The following returns information on server memory allocated
SELECT  
	(physical_memory_in_use_kb/1024) AS 'Memory used by SQL Server in MB',  
	(locked_page_allocations_kb/1024) AS 'Locked pages used by Sql Server MB',  
	(total_virtual_address_space_kb/1024) AS 'Total Virtual Address Space in MB',  
	process_physical_memory_low,  
	process_virtual_memory_low  
FROM sys.dm_os_process_memory;
GO

--Use the following to see a high level overview of memory usage on a server

SELECT * FROM sys.dm_os_performance_counters
WHERE object_name like '%Memory%'


--The following displays information regarding Memory information
SELECT object_name, 
	counter_name AS 'Counter Name', 
	instance_name AS 'Instance Name', 
	cntr_value AS 'Counter Value', 
	cntr_type AS 'Counter Type'  
FROM sys.dm_os_performance_counters
WHERE  (OBJECT_NAME = 'MSSQL$MSSQLSERVER01:Buffer Manager' --modify with server object name
	AND counter_name IN
	('Lazy writes/sec', 'Free list stalls/sec'))
OR
	(OBJECT_NAME = 'MSSQL$MSSQLSERVER01:Memory Manager' --modify with server object name
	AND counter_name IN
	('Memory Grants Outstanding', 'Memory Grants Pending'))
;
GO	

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>