/*70-762 Lesson 2.4 Lab 2 - Distinguishing Between Indexed Columns and Included Columns */

Use WideWorldImporters;
GO

DROP INDEX IF EXISTS IX_Purchasing_Suppliers_PostalCode
ON Purchasing.Suppliers;
GO

-- Creates a nonclustered index on the Purchasing.Suppliers table with three included (nonkey) columns.
-- index key column is PostalPostalCode and the nonkey columns are
-- PostalAddressLine1, PostalAddressLine2, and PostalCityID-------------------------------------------
CREATE NONCLUSTERED INDEX IX_Purchasing_Suppliers_PostalCode
ON Purchasing.Suppliers (PostalPostalCode)
INCLUDE (PostalAddressLine1, PostalAddressLine2, PostalCityID);
GO


/* Index Covers Query */
SELECT PostalAddressLine1, PostalAddressLine2, PostalCityID,PostalPostalCode
FROM Purchasing.Suppliers
WHERE PostalPostalCode BETWEEN '60000' AND '99999';
GO
  

/* Index Covering Query - Example 2 */
Use WideWorldImporters;
GO

DROP INDEX IF EXISTS IX_Sales_Orders_ContactPersonID_DateInfo
ON Sales.Orders;
GO

CREATE NONCLUSTERED INDEX IX_Sales_Orders_ContactPersonID_DateInfo
ON Sales.Orders (ContactPersonID)
INCLUDE (CustomerPurchaseOrderNumber,OrderDate, ExpectedDeliveryDate);
GO

SELECT ContactPersonID, CustomerPurchaseOrderNumber, OrderDate, ExpectedDeliveryDate
FROM Sales.Orders
WHERE ContactPersonID BETWEEN 1000  AND 1003;
GO

SELECT ContactPersonID, CustomerPurchaseOrderNumber, OrderDate, ExpectedDeliveryDate
FROM Sales.Orders
WHERE ContactPersonID = 1003
ORDER BY OrderDate
GO


/*-------------------------------------------------------------------------*/
--An extra example using AdventureWorks2016CTP3 database--------------------

USE AdventureWorks2016CTP3;
GO

DROP INDEX IF EXISTS IX_Address_PostalCode
ON Person.Address;
GO

-- Creates a nonclustered index on the Person.Address table with four included (nonkey) columns.
-- index key column is PostalCode and the nonkey columns are
-- AddressLine1, AddressLine2, City, and StateProvinceID.
CREATE NONCLUSTERED INDEX IX_Address_PostalCode
ON Person.Address (PostalCode)
INCLUDE (AddressLine1, AddressLine2, City, StateProvinceID);
GO

SELECT AddressLine1, AddressLine2, City, StateProvinceID, PostalCode
FROM Person.Address
WHERE PostalCode BETWEEN '98000' and '99999';
GO