/*  70-762 Lesson 1 Inline Code */

--Wide World Importers wants to provide a tool for sales staff
--which displays customer names, contact person, phone number, standard discount percentage

Use WideWorldImporters;
GO

SELECT c.CustomerID,c.CustomerName, p.FullName AS ContactPersonName, c.PhoneNumber, c.StandardDiscountPercentage
FROM Sales.Customers AS c
JOIN
Application.People AS p
ON  c.PrimaryContactPersonID = p.PersonID
ORDER BY c.CustomerName;
GO

DROP VIEW IF EXISTS Sales.vCustomerContactInfo;
GO


CREATE VIEW Sales.vCustomerContactInfo
AS
SELECT c.CustomerName AS Customer, p.FullName AS 'Contact Person', c.PhoneNumber, c.StandardDiscountPercentage
FROM Sales.Customers AS c
JOIN
Application.People AS p
ON  c.PrimaryContactPersonID = p.PersonID;
GO

SELECT *
FROM Sales.vCustomerContactInfo
ORDER BY Customer;
GO 



DROP VIEW IF EXISTS Sales.vCustomerContactInfo;
GO

-----------------------------------------------------------
-----------------------------------------------------------
--Providing a Reporting Interface-------------------------
USE WideWorldImporters;
GO

DROP VIEW IF EXISTS Application.vSouthwestSalesTerritory;
GO

CREATE OR ALTER VIEW Application.vSouthwestSalesTerritory
	WITH SCHEMABINDING
AS
SELECT  C.CityName, P.StateProvinceName
FROM Application.StateProvinces AS P
JOIN Application.Cities AS C
  ON P.StateProvinceID = C.StateProvinceID
  WHERE p.SalesTerritory = 'Southwest'; 
GO


SELECT *
FROM Application.vSouthwestSalesTerritory
ORDER BY CityName, StateProvinceName;
GO

SELECT *
FROM Application.vSouthwestSalesTerritory
ORDER BY StateProvinceName, CityName;
GO

--Add DROP VIEW to clean up lab - 
DROP VIEW IF EXISTS Application.vSouthwestSalesTerritory;
GO

