/* 70-762 Lesson 7 Lab 6 - Creating and Implementing Scalar-valued User-defined Functions */

USE WideWorldImporters;
GO

DROP FUNCTION IF EXISTS Sales.ufnCustomerTransactionAmount;
GO

-->>>>CREATE User-Defined Scalar-Valued Function<<<<-----------------------------
--Function sums all transaction amounts excluding tax for a given day-----------
--Input parameter is the requested date-----------------------------------------
CREATE FUNCTION Sales.ufnCustomerTransactionAmount     -- function name
(@TransactionDate datetime)                   -- input parameter name and data type
RETURNS decimal                               -- return parameter data type
 AS
 BEGIN                                        -- begin body definition
	DECLARE @ret decimal;
	SELECT @ret = SUM(ct.AmountExcludingTax)
	FROM Sales.CustomerTransactions AS ct
	WHERE ct.TransactionDate = @TransactionDate;
	RETURN @ret;                              -- action performed
END;
GO


USE WideWorldImporters;
GO

--Total amount in sales for a given day-------------------------------------------
SELECT DISTINCT TransactionDate,Sales.ufnCustomerTransactionAmount(TransactionDate) AS 'Total Daily Transactions Excluding Tax'
FROM Sales.CustomerTransactions
WHERE TransactionDate = '2016-05-31';
GO

--Total amount in sales for each day of the month--------------------------------
SELECT DISTINCT TransactionDate,
                Sales.ufnCustomerTransactionAmount(TransactionDate) AS 'Total Daily Transactions Excluding Tax'
FROM Sales.CustomerTransactions
WHERE TransactionDate BETWEEN '2016-05-01' AND '2016-05-31'
ORDER BY TransactionDate;
GO




