/*  70-762 Lesson 8 Inline Code */

USE [WideWorldImporters]
GO


DROP TABLE IF EXISTS Examples.CustTran;
GO

DROP TABLE IF EXISTS Examples.CustCatTran;
GO

SELECT CustomerCategoryID
      ,CustomerCategoryName
	INTO Examples.CustCatTran
FROM Sales.CustomerCategories
WHERE CustomerCategoryID IN (3, 4, 5, 6);
GO

ALTER TABLE Examples.CustCatTran
ADD CONSTRAINT PK_CustCatTran_CustomerCategoryID PRIMARY KEY CLUSTERED (CustomerCategoryID);
GO


SELECT CustomerID
      ,CustomerCategoryID
	  ,CustomerName
	 INTO Examples.CustTran 
FROM Sales.Customers
WHERE CustomerID BETWEEN 905 AND 910;
GO

ALTER TABLE Examples.CustTran
ADD CONSTRAINT PK_CustTran_CustomerID PRIMARY KEY CLUSTERED (CustomerID);
GO

ALTER TABLE Examples.CustTran
ADD CONSTRAINT FK_CustTran_Ref_CustCatTran
	FOREIGN KEY (CustomerCategoryID) REFERENCES Examples.CustCatTran(CustomerCategoryID);
GO

SELECT * FROM Examples.CustCatTran;
SELECT * FROM Examples.CustTran;


BEGIN TRANSACTION;
	UPDATE Examples.CustCatTran
	SET CustomerCategoryName = 'Novelty Toy Shop'
	WHERE CustomerCategoryName = 'Novelty Shop';

	UPDATE Examples.CustTran
	SET CustomerName = 'Minnie Mouse'
	WHERE CustomerName = 'Sumati Bhat';
COMMIT TRANSACTION;

SELECT CustCatTran.CustomerCategoryID, CustomerCategoryName, CustomerID, CustomerName
FROM Examples.CustCatTran
	FULL OUTER JOIN
	Examples.CustTran
ON CustCatTran.CustomerCategoryID = CustTran.CustomerCategoryID;
GO





DROP TABLE IF EXISTS Examples.CustTran;
GO

DROP TABLE IF EXISTS Examples.CustCatTran;
GO

--/////////////////////////////////////////////
----------------------------------------------
DECLARE @IMPLICIT_TRANSACTIONS VARCHAR(3) = 'OFF';
  IF ( (2 & @@OPTIONS) = 2 ) SET @IMPLICIT_TRANSACTIONS = 'ON';
SELECT @IMPLICIT_TRANSACTIONS AS IMPLICIT_TRANSACTIONS;
GO

--------------------------------------------------
--Using @@OPTIONS To get the settings for the current session -----

DECLARE @options INT 
SELECT @options = @@OPTIONS 
PRINT @options
IF ( (1 & @options) = 1 ) PRINT 'DISABLE_DEF_CNST_CHK' 
IF ( (2 & @options) = 2 ) PRINT 'IMPLICIT_TRANSACTIONS' 
IF ( (4 & @options) = 4 ) PRINT 'CURSOR_CLOSE_ON_COMMIT' 
IF ( (8 & @options) = 8 ) PRINT 'ANSI_WARNINGS' 
IF ( (16 & @options) = 16 ) PRINT 'ANSI_PADDING' 
IF ( (32 & @options) = 32 ) PRINT 'ANSI_NULLS' 
IF ( (64 & @options) = 64 ) PRINT 'ARITHABORT' 
IF ( (128 & @options) = 128 ) PRINT 'ARITHIGNORE'
IF ( (256 & @options) = 256 ) PRINT 'QUOTED_IDENTIFIER' 
IF ( (512 & @options) = 512 ) PRINT 'NOCOUNT' 
IF ( (1024 & @options) = 1024 ) PRINT 'ANSI_NULL_DFLT_ON' 
IF ( (2048 & @options) = 2048 ) PRINT 'ANSI_NULL_DFLT_OFF' 
IF ( (4096 & @options) = 4096 ) PRINT 'CONCAT_NULL_YIELDS_NULL' 
IF ( (8192 & @options) = 8192 ) PRINT 'NUMERIC_ROUNDABORT' 
IF ( (16384 & @options) = 16384 ) PRINT 'XACT_ABORT' 
