/* 70-762 Lesson 8 Lab 4 - Implementing and Managing Locks */

-->>>>>>Transaction Isolation Level set for the session<<<<<<-----------
--Shared locks held until the end of the session------------------------
USE AdventureWorks2016CTP3;
GO

--Check Isolation Mode ------------------------------------------
--rsc_type:
----------2 = database
----------3 = file
----------5 = table
----------6 = page
----------7 = key
--req_mode: (transaction isolation mode)
----------3 = S (Shared) The holding session is granted shared access to the resource
----------5 = X (Exclusive) The holding session is granted exclusive access to the resource
----------6 = IS (Intent Shared) Indicates the intention to place S locks on some subordinate resource in the lock hierarchy
----------13 = RangeS_S (Shared Key-Range and Shared Resource lock) Indicates serializable range scan
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO 


SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
GO

BEGIN TRANSACTION;
SELECT * 
    FROM HumanResources.EmployeePayHistory;
--Check Isolation Mode ------------------------------------------
--3 = S (Shared). The holding session is granted shared access to the resource
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
----Continue with transaction----------------------------------------
SELECT * 
    FROM HumanResources.Department;
COMMIT TRANSACTION;
GO
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>>>Transaction Isolation Level set for the session<<<<<<-----------
--Next Change the Isolation Level to Serializable-----------------------
USE AdventureWorks2016CTP3;
GO
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
GO

BEGIN TRANSACTION;
SELECT * 
    FROM HumanResources.EmployeePayHistory;
--Check Isolation Mode ------------------------------------------
--13 = RangeS_S (Shared Key-Range and Shared Resource lock). Indicates serializable range scan.
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
----Continue with transaction----------------------------------------
SELECT * 
    FROM HumanResources.Department;
COMMIT TRANSACTION;

-->>>>>>>>>>>Check After Commit<<<<<<___________________
--Check Isolation Mode ------------------------------------------
--3 = S (Shared). The holding session is granted shared access to the resource (Default)
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO

---------------------------------------------------------------
----------------------------------------------------------------
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
GO