/* Lesson 9 Lab 1 Connection 2 - Implementing Results of Concurrent Queries Using SET TRANSACTION ISOLATION LEVEL*/

--QUERY WINDOW 2---------------
--Connection 2-----------------

-----Example 1  Connection 2--------------------------
 -----READ UNCOMMITTED ISOLATION LEVEL---
 --Open a transaction and update the price of an item
 --Keep transaction from Connection 1 open
 USE WideWorldImporters;
 GO

SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;

SELECT OrderLineID, UnitPrice
FROM Examples.IsoLevels
WHERE OrderLineID = 3;
---Note the price has been updated even though the tran was not committed
--Return to Connection 1


/*****************************************************/
-----Example 2  Connection 2--------------------------
 -----READ COMMITTED ISOLATION LEVEL---
 --Open a transaction and update the price of an item
 --Keep transaction from connection 1 open

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;

SELECT OrderLineID, UnitPrice
FROM Examples.IsoLevels
WHERE OrderLineID = 3;
---Note the SELECT statement is blocked
---The shared lock needed for the read is in conflict with exclusive lock
---of update in connection 1
--Return to Connection 1

--Come back after transaction committed in connection 1
SELECT OrderLineID, UnitPrice
FROM Examples.IsoLevels
WHERE OrderLineID = 3;

/******************************************************************/
/******************************************************************/
/******************************************************************/
-----Example 3  Connection 2--------------------------
 -----REPEATABLE READ ISOLATION LEVEL---
 --Open a transaction and update the price of an item
 --Keep transaction from connection 1 open

	UPDATE Examples.IsoLevels
	SET UnitPrice +=10.00
	WHERE OrderLineID = 3;  --initial unitprice is 13.00

--Update is block because connection 1 still holds shared lock
--Return back to connection 1------

/**********************************************************/
/**********************************************************/
/**********************************************************/
/*****************************************************/
-----Example 4  Connection 2--------------------------
-----SERIALIZABLE ISOLATION LEVEL---
--This example shows that serializable isolation level
--prevents phantom reads------------------------------
--Attempt to insert a new product with OrderID 4------
--With SERIALIZABLE the attempt is blocked------------

INSERT INTO  Examples.IsoLevels 
	 (OrderLineID
      ,OrderID
      ,StockItemID
      ,Description
      ,Quantity
      ,UnitPrice)
  VALUES (40, 4, 200, 'SQL Rules Sweatshirt One Size',20, 25.00);

--Return to connection 1-----------------

/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/*****************************************************/
-----Example 5  Connection 2--------------------------
--With SNAPSHOT ISOLATION LEVEL,
--the last committed version of the data available at start
--of transaction is output---------------------------------
SET TRANSACTION ISOLATION LEVEL SNAPSHOT;

BEGIN TRAN;
	SELECT OrderLineID, UnitPrice
	FROM Examples.IsoLevels
	WHERE OrderLineID = 3;

--Return to connection 1-----------------

--Now read data again-------------------
--Update does not appear in connection 2
	SELECT OrderLineID, UnitPrice
	FROM Examples.IsoLevels
	WHERE OrderLineID = 3;

COMMIT TRAN;

--Next open and commit a new tran-------
--Data has now been updated
BEGIN TRAN;
	SELECT OrderLineID, UnitPrice
	FROM Examples.IsoLevels
	WHERE OrderLineID = 3;
COMMIT TRAN;

--Return to connection 1
--for lab cleanup